# -*- coding: utf-8 -*-

"""
shellcardmanagementapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shellcardmanagementapis.api_helper import APIHelper


class PINReminderReference(object):

    """Implementation of the 'PINReminderReference' model.

    This class holds the PIN Reminder References

    Attributes:
        card_id (int): Card Id
        panid (int): PAN ID
        pan (int): PAN
        card_expiry_date (str): Expiry date of the card.  Mandatory if Either
            PAN or PANID is passed, else optional.  Format: yyyyMMdd
        reference_id (int): Individual card pin reminder reference number for
            the Pin Reminder request.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "card_id": 'CardId',
        "panid": 'PANID',
        "pan": 'PAN',
        "card_expiry_date": 'CardExpiryDate',
        "reference_id": 'ReferenceId'
    }

    _optionals = [
        'card_id',
        'panid',
        'pan',
        'card_expiry_date',
        'reference_id',
    ]

    _nullables = [
        'card_id',
        'panid',
        'pan',
        'card_expiry_date',
    ]

    def __init__(self,
                 card_id=APIHelper.SKIP,
                 panid=APIHelper.SKIP,
                 pan=APIHelper.SKIP,
                 card_expiry_date=APIHelper.SKIP,
                 reference_id=APIHelper.SKIP):
        """Constructor for the PINReminderReference class"""

        # Initialize members of the class
        if card_id is not APIHelper.SKIP:
            self.card_id = card_id 
        if panid is not APIHelper.SKIP:
            self.panid = panid 
        if pan is not APIHelper.SKIP:
            self.pan = pan 
        if card_expiry_date is not APIHelper.SKIP:
            self.card_expiry_date = card_expiry_date 
        if reference_id is not APIHelper.SKIP:
            self.reference_id = reference_id 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        card_id = dictionary.get("CardId") if "CardId" in dictionary.keys() else APIHelper.SKIP
        panid = dictionary.get("PANID") if "PANID" in dictionary.keys() else APIHelper.SKIP
        pan = dictionary.get("PAN") if "PAN" in dictionary.keys() else APIHelper.SKIP
        card_expiry_date = dictionary.get("CardExpiryDate") if "CardExpiryDate" in dictionary.keys() else APIHelper.SKIP
        reference_id = dictionary.get("ReferenceId") if dictionary.get("ReferenceId") else APIHelper.SKIP
        # Return an object of this model
        return cls(card_id,
                   panid,
                   pan,
                   card_expiry_date,
                   reference_id)
