# -*- coding: utf-8 -*-

"""
shellcardmanagementapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shellcardmanagementapis.api_helper import APIHelper


class RestrictionCardResponseDataItems(object):

    """Implementation of the 'RestrictionCardResponseDataItems' model.

    TODO: type model description here.

    Attributes:
        account_id (int): Account Id of the customer.
        account_number (str): Account Number of the customer.
        card_id (int): Unique Card Id
        day_time_restriction_description (str): This field will have a value
            only when “DayTimeRestrictionStatus” is “Failed”.
        day_time_restriction_status (str): Status of the card day/time
            restriction submitted to API. Based on the response from API value
            will be set as either “Success” or “Failed”.
        location_restriction_description (str): This field will have a value
            only when “LocationRestrictionStatus” is “Failed”.
        location_restriction_status (str): Card Location restriction submitted
            to gateway based on gateway response value set as “Success” or
            “Failed”.
        pan (str): Card PAN
        product_restriction_description (str): This field will have a value
            only when “ProductRestrictionStatus” is “Failed”.
        product_restriction_status (str): Status of the card product
            restriction submitted
        usage_restriction_description (str): This field will have a value only
            when “UsageRestrictionStatus” is “Failed”.
        usage_restriction_status (str): Status of the card usage restriction
            submitted
        validation_error_code (str): Error code for validation failure. 
            Example error codes:  0007, 9007, 7000, 7001.
        validation_error_description (str): Description of validation
            failure.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "account_id": 'AccountId',
        "account_number": 'AccountNumber',
        "card_id": 'CardId',
        "day_time_restriction_description": 'DayTimeRestrictionDescription',
        "day_time_restriction_status": 'DayTimeRestrictionStatus',
        "location_restriction_description": 'LocationRestrictionDescription',
        "location_restriction_status": 'LocationRestrictionStatus',
        "pan": 'PAN',
        "product_restriction_description": 'ProductRestrictionDescription',
        "product_restriction_status": 'ProductRestrictionStatus',
        "usage_restriction_description": 'UsageRestrictionDescription',
        "usage_restriction_status": 'UsageRestrictionStatus',
        "validation_error_code": 'ValidationErrorCode',
        "validation_error_description": 'ValidationErrorDescription'
    }

    _optionals = [
        'account_id',
        'account_number',
        'card_id',
        'day_time_restriction_description',
        'day_time_restriction_status',
        'location_restriction_description',
        'location_restriction_status',
        'pan',
        'product_restriction_description',
        'product_restriction_status',
        'usage_restriction_description',
        'usage_restriction_status',
        'validation_error_code',
        'validation_error_description',
    ]

    _nullables = [
        'account_id',
        'account_number',
        'card_id',
        'day_time_restriction_description',
        'day_time_restriction_status',
        'location_restriction_description',
        'location_restriction_status',
        'pan',
        'product_restriction_description',
        'product_restriction_status',
        'usage_restriction_description',
        'usage_restriction_status',
        'validation_error_code',
        'validation_error_description',
    ]

    def __init__(self,
                 account_id=APIHelper.SKIP,
                 account_number=APIHelper.SKIP,
                 card_id=APIHelper.SKIP,
                 day_time_restriction_description=APIHelper.SKIP,
                 day_time_restriction_status=APIHelper.SKIP,
                 location_restriction_description=APIHelper.SKIP,
                 location_restriction_status=APIHelper.SKIP,
                 pan=APIHelper.SKIP,
                 product_restriction_description=APIHelper.SKIP,
                 product_restriction_status=APIHelper.SKIP,
                 usage_restriction_description=APIHelper.SKIP,
                 usage_restriction_status=APIHelper.SKIP,
                 validation_error_code=APIHelper.SKIP,
                 validation_error_description=APIHelper.SKIP):
        """Constructor for the RestrictionCardResponseDataItems class"""

        # Initialize members of the class
        if account_id is not APIHelper.SKIP:
            self.account_id = account_id 
        if account_number is not APIHelper.SKIP:
            self.account_number = account_number 
        if card_id is not APIHelper.SKIP:
            self.card_id = card_id 
        if day_time_restriction_description is not APIHelper.SKIP:
            self.day_time_restriction_description = day_time_restriction_description 
        if day_time_restriction_status is not APIHelper.SKIP:
            self.day_time_restriction_status = day_time_restriction_status 
        if location_restriction_description is not APIHelper.SKIP:
            self.location_restriction_description = location_restriction_description 
        if location_restriction_status is not APIHelper.SKIP:
            self.location_restriction_status = location_restriction_status 
        if pan is not APIHelper.SKIP:
            self.pan = pan 
        if product_restriction_description is not APIHelper.SKIP:
            self.product_restriction_description = product_restriction_description 
        if product_restriction_status is not APIHelper.SKIP:
            self.product_restriction_status = product_restriction_status 
        if usage_restriction_description is not APIHelper.SKIP:
            self.usage_restriction_description = usage_restriction_description 
        if usage_restriction_status is not APIHelper.SKIP:
            self.usage_restriction_status = usage_restriction_status 
        if validation_error_code is not APIHelper.SKIP:
            self.validation_error_code = validation_error_code 
        if validation_error_description is not APIHelper.SKIP:
            self.validation_error_description = validation_error_description 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        account_id = dictionary.get("AccountId") if "AccountId" in dictionary.keys() else APIHelper.SKIP
        account_number = dictionary.get("AccountNumber") if "AccountNumber" in dictionary.keys() else APIHelper.SKIP
        card_id = dictionary.get("CardId") if "CardId" in dictionary.keys() else APIHelper.SKIP
        day_time_restriction_description = dictionary.get("DayTimeRestrictionDescription") if "DayTimeRestrictionDescription" in dictionary.keys() else APIHelper.SKIP
        day_time_restriction_status = dictionary.get("DayTimeRestrictionStatus") if "DayTimeRestrictionStatus" in dictionary.keys() else APIHelper.SKIP
        location_restriction_description = dictionary.get("LocationRestrictionDescription") if "LocationRestrictionDescription" in dictionary.keys() else APIHelper.SKIP
        location_restriction_status = dictionary.get("LocationRestrictionStatus") if "LocationRestrictionStatus" in dictionary.keys() else APIHelper.SKIP
        pan = dictionary.get("PAN") if "PAN" in dictionary.keys() else APIHelper.SKIP
        product_restriction_description = dictionary.get("ProductRestrictionDescription") if "ProductRestrictionDescription" in dictionary.keys() else APIHelper.SKIP
        product_restriction_status = dictionary.get("ProductRestrictionStatus") if "ProductRestrictionStatus" in dictionary.keys() else APIHelper.SKIP
        usage_restriction_description = dictionary.get("UsageRestrictionDescription") if "UsageRestrictionDescription" in dictionary.keys() else APIHelper.SKIP
        usage_restriction_status = dictionary.get("UsageRestrictionStatus") if "UsageRestrictionStatus" in dictionary.keys() else APIHelper.SKIP
        validation_error_code = dictionary.get("ValidationErrorCode") if "ValidationErrorCode" in dictionary.keys() else APIHelper.SKIP
        validation_error_description = dictionary.get("ValidationErrorDescription") if "ValidationErrorDescription" in dictionary.keys() else APIHelper.SKIP
        # Return an object of this model
        return cls(account_id,
                   account_number,
                   card_id,
                   day_time_restriction_description,
                   day_time_restriction_status,
                   location_restriction_description,
                   location_restriction_status,
                   pan,
                   product_restriction_description,
                   product_restriction_status,
                   usage_restriction_description,
                   usage_restriction_status,
                   validation_error_code,
                   validation_error_description)
