# -*- coding: utf-8 -*-

"""
shellcardmanagementapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from shellcardmanagementapis.api_helper import APIHelper
from shellcardmanagementapis.models.summary_of_bundle_response_data_items_card_bundles_items import SummaryOfBundleResponseDataItemsCardBundlesItems


class SummaryOfBundleResponseDataItems(object):

    """Implementation of the 'SummaryOfBundleResponseDataItems' model.

    TODO: type model description here.

    Attributes:
        payer_id (int): Payer Id of the bundles and cards.  Example: 123456
        payer_number (str): Payer Number of the bundles and cards.  Example:
            GB000000123
        account_id (int): Account ID of the bundle.  Example: 123456
        account_number (str): Account Number of the bundle.  Example:
            GB000000123
        count_of_cards_not_in_bundle (int): Count of cards that are not part
            of the bundle in a given account.
        card_bundles (List[SummaryOfBundleResponseDataItemsCardBundlesItems]):
            List of Card Bundles

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "payer_id": 'PayerId',
        "payer_number": 'PayerNumber',
        "account_id": 'AccountId',
        "account_number": 'AccountNumber',
        "count_of_cards_not_in_bundle": 'CountOfCardsNotInBundle',
        "card_bundles": 'CardBundles'
    }

    _optionals = [
        'payer_id',
        'payer_number',
        'account_id',
        'account_number',
        'count_of_cards_not_in_bundle',
        'card_bundles',
    ]

    _nullables = [
        'payer_id',
        'payer_number',
        'account_id',
        'account_number',
        'count_of_cards_not_in_bundle',
    ]

    def __init__(self,
                 payer_id=APIHelper.SKIP,
                 payer_number=APIHelper.SKIP,
                 account_id=APIHelper.SKIP,
                 account_number=APIHelper.SKIP,
                 count_of_cards_not_in_bundle=APIHelper.SKIP,
                 card_bundles=APIHelper.SKIP):
        """Constructor for the SummaryOfBundleResponseDataItems class"""

        # Initialize members of the class
        if payer_id is not APIHelper.SKIP:
            self.payer_id = payer_id 
        if payer_number is not APIHelper.SKIP:
            self.payer_number = payer_number 
        if account_id is not APIHelper.SKIP:
            self.account_id = account_id 
        if account_number is not APIHelper.SKIP:
            self.account_number = account_number 
        if count_of_cards_not_in_bundle is not APIHelper.SKIP:
            self.count_of_cards_not_in_bundle = count_of_cards_not_in_bundle 
        if card_bundles is not APIHelper.SKIP:
            self.card_bundles = card_bundles 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        payer_id = dictionary.get("PayerId") if "PayerId" in dictionary.keys() else APIHelper.SKIP
        payer_number = dictionary.get("PayerNumber") if "PayerNumber" in dictionary.keys() else APIHelper.SKIP
        account_id = dictionary.get("AccountId") if "AccountId" in dictionary.keys() else APIHelper.SKIP
        account_number = dictionary.get("AccountNumber") if "AccountNumber" in dictionary.keys() else APIHelper.SKIP
        count_of_cards_not_in_bundle = dictionary.get("CountOfCardsNotInBundle") if "CountOfCardsNotInBundle" in dictionary.keys() else APIHelper.SKIP
        card_bundles = None
        if dictionary.get('CardBundles') is not None:
            card_bundles = [SummaryOfBundleResponseDataItemsCardBundlesItems.from_dictionary(x) for x in dictionary.get('CardBundles')]
        else:
            card_bundles = APIHelper.SKIP
        # Return an object of this model
        return cls(payer_id,
                   payer_number,
                   account_id,
                   account_number,
                   count_of_cards_not_in_bundle,
                   card_bundles)
